#!/usr/verylocal/bin/python

import os
import re
import cgi

tag_start = '<pre>'
tag_end   = '</pre>'
def replace_pre (s):
    beg = s.find (tag_start)
    if beg == -1:
        return s
    end = s.find (tag_end, beg)
    if end == -1:
        raise "bogus" + s
    replaced = cgi.escape (s[beg + len (tag_start):end]).replace (
        '\n', '<br />')
    return s[0:beg] +  tag_start + replaced + replace_pre (s[end:])

def mk_slides (inp, out):
    slide_list = open (os.path.join (inp, "contents")).readlines ()
    def mk_ref (s):
        return s + ".html"
    slide_list = [s.rstrip () for s in slide_list]
    titles = []
    for i, s in enumerate (slide_list):
        s = s.rstrip ()
        in_f = open (os.path.join (inp, s))
        title = in_f.readline ()
        titles.append (title)
        rest = in_f.read ()
        rest = replace_pre (rest)
        out_f = open (os.path.join (out, mk_ref (s)), "w")
        out_f.write ("<html><head><title>" + title + "</title></head>")
        out_f.write ("<body><div>")
        if i <> 0:
            out_f.write ('<a href="%s">Prev</a>' % (mk_ref (slide_list[i-1])))
        if i <> len (slide_list) - 1:
            out_f.write ('        <a href="%s">Next</a>' % (mk_ref (slide_list[i+1])))
        out_f.write ('</div>')
        out_f.write (rest)
        out_f.write ("</body></html>")
        out_f.close ()
    index = open (os.path.join (out, mk_ref ("index")), "w")
    index.write ("""<html><head><title>Table of Contents</title></head>
    <body><p><ol>""")
    for t, s in zip(titles, slide_list):
        index.write ('<li><a href="%s">%s</a></li>\n' % (mk_ref (s), t))
    index.write ("</ol></p></body></html>")
    index.close ()
                 

inp_dir = "inp"
out_dir = "out"

if __name__ == '__main__':
    mk_slides (inp_dir, out_dir)
    

    
        
        

        
